【澳门葡京】浅谈NodeJs之数据库相当管理,NodeJs之数据库非凡管理

数据库卓殊


NodeJs版本:4.4.4

数据库十分


NodeJs版本:4.4.4

浅谈NodeJs之数据库格外处理,浅谈nodejs分外管理

正文介绍了NodeJs之数据库格外管理,分享给大家,具体如下:

NodeJs版本:4.4.4

数据库链接错误

运用nodejs处理相当最麻烦但是,那里小编丢弃nodejs提供的domain和有个别第二方库专门管理的东西。操作数据库是大家常用的功效。通过回调,大家那里会有许多err出没。

如下:

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
  return new Promise(function(resolve, reject) {
    pool.getConnection(function(err, connection) {

      //connection.query(queryString, function(err, rows, fields) {

      // if (!err) {
      //   resolve(rows);
      //  } else {
      //   runtimeLog.error(err)
      //   reject(err)
      //  }
      // connection.release();
      //});
    })
  })
}

module.exports = function() {
  return new Promise(function(resolve, reject) {

    queryPromise("select * from wb123_home_map GROUP BY onestair")
      .then(function(results){
        resolve(results);

      })
      .catch(function(err){
        runtimeLog.error(err)
      })
  })
}

能够观察1个回调的地方都会有失误的大概。

并且那是贰个模块,大家将它导出了。

此地大家有意识将数据库链接的端口号填错,写成330666:

module.exports = {
  host:   '192.168.6.101',
  database: 'web123',
  user:   'root',
  password: 'passw0rd',
  protocol: 'mysql',
  port:   '330666',
  query:  {pool: true}
}

这样的话,在我们链接数据库的时候是会出错的。

此处我们使用了promise,所以在导出的函数中,大家应用了catch,他会抓到queryPromise函数中的错误,并打字与印刷到日志中。

[2017-01-05 13:27:59.648] [ERROR] runlog - [err] [RangeError: port should be >= 0 and < 65536: 330666]
RangeError: port should be >= 0 and < 65536: 330666
...

数据库sql语句错误

大家修改一下代码,将数据库链接填对,修改sql语句为错误的言语。

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
  return new Promise(function(resolve, reject) {
    pool.getConnection(function(err, connection) {

      connection.query(queryString, function(err, rows, fields) {
        //if (err) throw err;
        if (!err) {
          resolve(rows);
         } else {
          reject(err)
         }
        connection.release();
      });
    })
  })
}

module.exports = function() {
  return new Promise(function(resolve, reject) {

    queryPromise("select * from wb123_home_map GROUP BY onestairs")
      .then(function(results){
        resolve(results);

      })
      .catch(function(err){
        runtimeLog.error('[err]',err)
      })
  })
}

报错音讯:

[2017-01-05 14:40:14.518] [ERROR] runlog - [err] { [Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement']
 code: 'ER_BAD_FIELD_ERROR',
 errno: 1054,
 sqlState: '42S22',
 index: 0 }
Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement'
  at Query.Sequence._packetToError (E:\zz\zz_wb123\manage\trunk\code\nod
....

能够看来错误都以透过catch抛出。

因而借使采取了Promise大家能够直接在catch中抓到上边抛出的那多少个。不须要再去queryPromise函数中打日志分外了。

【澳门葡京】浅谈NodeJs之数据库相当管理,NodeJs之数据库非凡管理。此处有一篇stackoverflow处理错误的不得了有效的问答node-js-best-practice-exception-handling

以上正是本文的全部内容,希望对大家的求学抱有帮助,也期待大家多多补助帮客之家。

本文介绍了NodeJs之数据库十分管理,分享给我们,具体如下:
NodeJs版本:四.四.4 数据库链接错…

正文介绍了NodeJs之数据库非凡管理,分享给大家,具体如下:

数据库链接错误

使用nodejs管理极度最艰巨不过,那里小编舍弃nodejs提供的domain和有些第一方库专门管理的东西。操作数据库是我们常用的功能。通过回调,大家那边会有众多err出没。

如下:

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            //connection.query(queryString, function(err, rows, fields) {

            //  if (!err) {
            //      resolve(rows);
            //   } else {
            //      runtimeLog.error(err)
            //      reject(err)
            //   }
            //  connection.release();
            //});
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestair")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error(err)
            })
    })
}

能够看看1个回调的地点都会有失误的可能。

澳门葡京,与此同时那是贰个模块,大家将它导出了。

此地大家有意识将数据库链接的端口号填错,写成33066六:

module.exports = {
    host:     '192.168.6.101',
    database: 'web123',
    user:     'root',
    password: 'passw0rd',
    protocol: 'mysql',
    port:     '330666',
    query:    {pool: true}
}

那样的话,在大家链接数据库的时候是会出错的。

此间大家选用了promise,所以在导出的函数中,我们应用了catch,他会抓到queryPromise函数中的错误,并打字与印刷到日志中。

[2017-01-05 13:27:59.648] [ERROR] runlog - [err] [RangeError: port should be >= 0 and < 65536: 330666]
RangeError: port should be >= 0 and < 65536: 330666
...

数据库链接错误

行使nodejs处理相当最麻烦然则,那里本人抛弃nodejs提供的domain和部分第一方库专门管理的事物。操作数据库是大家常用的职能。通过回调,大家那里会有多数err出没。

如下:

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            //connection.query(queryString, function(err, rows, fields) {

            //  if (!err) {
            //      resolve(rows);
            //   } else {
            //      runtimeLog.error(err)
            //      reject(err)
            //   }
            //  connection.release();
            //});
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestair")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error(err)
            })
    })
}

能够观看一个回调的地点都会有疏失的大概。

并且那是3个模块,大家将它导出了。

此间我们有意将数据库链接的端口号填错,写成33066陆:

module.exports = {
    host:     '192.168.6.101',
    database: 'web123',
    user:     'root',
    password: 'passw0rd',
    protocol: 'mysql',
    port:     '330666',
    query:    {pool: true}
}

这样的话,在大家链接数据库的时候是会出错的。

此处大家使用了promise,所以在导出的函数中,大家应用了catch,他会抓到queryPromise函数中的错误,并打字与印刷到日志中。

[2017-01-05 13:27:59.648] [ERROR] runlog - [err] [RangeError: port should be >= 0 and < 65536: 330666]
RangeError: port should be >= 0 and < 65536: 330666
...

NodeJs版本:4.4.4

数据库sql语句错误

大家修改一下代码,将数据库链接填对,修改sql语句为不当的言语。

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            connection.query(queryString, function(err, rows, fields) {
                //if (err) throw err;
                if (!err) {
                    resolve(rows);
                 } else {
                    reject(err)
                 }
                connection.release();
            });
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestairs")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error('[err]',err)
            })
    })
}

报错音讯:

[2017-01-05 14:40:14.518] [ERROR] runlog - [err] { [Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement']
  code: 'ER_BAD_FIELD_ERROR',
  errno: 1054,
  sqlState: '42S22',
  index: 0 }
Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement'
    at Query.Sequence._packetToError (E:\zz\zz_wb123\manage\trunk\code\nod
....

可以看来错误都以经过catch抛出。

故此只要选择了Promise我们得以一向在catch中抓到下边抛出的10分。不供给再去queryPromise函数中打日志格外了。

此间有1篇stackoverflow管理错误的老大管用的问答node-js-best-practice-exception-handling

数据库sql语句错误

我们修改一下代码,将数据库链接填对,修改sql语句为错误的言语。

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            connection.query(queryString, function(err, rows, fields) {
                //if (err) throw err;
                if (!err) {
                    resolve(rows);
                 } else {
                    reject(err)
                 }
                connection.release();
            });
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestairs")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error('[err]',err)
            })
    })
}

报错音信:

[2017-01-05 14:40:14.518] [ERROR] runlog - [err] { [Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement']
  code: 'ER_BAD_FIELD_ERROR',
  errno: 1054,
  sqlState: '42S22',
  index: 0 }
Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement'
    at Query.Sequence._packetToError (E:\zz\zz_wb123\manage\trunk\code\nod
....

可以看来错误都以透过catch抛出。

因而若是使用了Promise我们能够直接在catch中抓到上面抛出的要命。不须要再去queryPromise函数中打日志非常了。

此间有一篇stackoverflow管理错误的万分实用的问答node-js-best-practice-exception-handling

数据库链接错误

运用nodejs管理万分最费劲然则,那里小编放弃nodejs提供的domain和局地第贰方库专门处理的东西。操作数据库是大家常用的成效。通过回调,大家那边会有大多err出没。

如下:

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
  return new Promise(function(resolve, reject) {
    pool.getConnection(function(err, connection) {

      //connection.query(queryString, function(err, rows, fields) {

      // if (!err) {
      //   resolve(rows);
      //  } else {
      //   runtimeLog.error(err)
      //   reject(err)
      //  }
      // connection.release();
      //});
    })
  })
}

module.exports = function() {
  return new Promise(function(resolve, reject) {

    queryPromise("select * from wb123_home_map GROUP BY onestair")
      .then(function(results){
        resolve(results);

      })
      .catch(function(err){
        runtimeLog.error(err)
      })
  })
}

能够观望二个回调的地点都会有疏失的或是。

而且那是三个模块,大家将它导出了。

此地大家有意将数据库链接的端口号填错,写成33066陆:

module.exports = {
  host:   '192.168.6.101',
  database: 'web123',
  user:   'root',
  password: 'passw0rd',
  protocol: 'mysql',
  port:   '330666',
  query:  {pool: true}
}

这样的话,在我们链接数据库的时候是会出错的。

那边大家应用了promise,所以在导出的函数中,大家利用了catch,他会抓到queryPromise函数中的错误,并打字与印刷到日志中。

[2017-01-05 13:27:59.648] [ERROR] runlog - [err] [RangeError: port should be >= 0 and < 65536: 330666]
RangeError: port should be >= 0 and < 65536: 330666
...

数据库sql语句错误

咱俩修改一下代码,将数据库链接填对,修改sql语句为错误的说话。

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
  return new Promise(function(resolve, reject) {
    pool.getConnection(function(err, connection) {

      connection.query(queryString, function(err, rows, fields) {
        //if (err) throw err;
        if (!err) {
          resolve(rows);
         } else {
          reject(err)
         }
        connection.release();
      });
    })
  })
}

module.exports = function() {
  return new Promise(function(resolve, reject) {

    queryPromise("select * from wb123_home_map GROUP BY onestairs")
      .then(function(results){
        resolve(results);

      })
      .catch(function(err){
        runtimeLog.error('[err]',err)
      })
  })
}

报错信息:

[2017-01-05 14:40:14.518] [ERROR] runlog - [err] { [Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement']
 code: 'ER_BAD_FIELD_ERROR',
 errno: 1054,
 sqlState: '42S22',
 index: 0 }
Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement'
  at Query.Sequence._packetToError (E:\zz\zz_wb123\manage\trunk\code\nod
....

能够看看错误都以经过catch抛出。

为此只要运用了Promise我们能够直接在catch中抓到上面抛出的13分。不要求再去queryPromise函数中打日志格外了。

那边有1篇stackoverflow管理错误的丰裕实用的问答node-js-best-practice-exception-handling

以上正是本文的全体内容,希望对大家的读书抱有协助,也期待大家多多帮忙脚本之家。

你大概感兴趣的稿子:

  • Nodejs异步回调的幽雅管理形式
  • 剖析Node.js十分管理中domain模块的运用方法
  • 采纳nodejs中httpProxy代理时候出现40四要命的化解办法
  • Node.js
    异步至极的拍卖与domain模块解析
  • NodeJS管理Express中异步错误
  • 利用Raygun对Node.js应用进行错误管理的艺术
  • Node错误管理笔记之挖坑种类教程
  • Nodejs异步回调之十分管理实例分析

相关文章

发表评论

电子邮件地址不会被公开。 必填项已用*标注

*
*
Website